package bpm.vanilla.platform.core.beans.service;


/**
 * Represents an output element generated by the service.
 * 
 * Has a name, a formula used to calculate it and reference 
 * the input elements which the data come from
 * 
 * @author Marc Lanquetin
 *
 */
public class ServiceOutputData implements IService {
		
	private int id;
	private String name;
	private int type;
	private String value;

	private ServiceTransformationDefinition definition;

	@Override
	public String getName() {
		return name;
	}

	@Override
	public void setName(String name) {
		this.name = name;
	}

	@Override
	public void setValue(String value) {
		this.value = value;
	}

	@Override
	public String getValue() {
		return value;
	}

	public void setId(int id) {
		this.id = id;
	}

	public int getId() {
		return id;
	}

	@Override
	public void setType(int type) {
		this.type = type;
	}

	@Override
	public int getType() {
		return type;
	}

	public ServiceTransformationDefinition getDefinition() {
		return definition;
	}

	public void setDefinition(ServiceTransformationDefinition definition) {
		this.definition = definition;
	}
	
}
